#include "thread/Spinlock.h"
#include "Log.h"
#include "arch/CPU.h"

void Spinlock::lock()
{
    int expected = 0;
    while (!m_lock.compare_exchange_strong(expected, 1))
    {
        expected = 0;
        CPU::pause();
    }
}

bool Spinlock::try_lock()
{
    int expected = 0;
    return m_lock.compare_exchange_strong(expected, 1);
}

void Spinlock::unlock()
{
    int expected = 1;
    if (!m_lock.compare_exchange_strong(expected, 0))
    {
        kwarnln("Spinlock::unlock() called on an unlocked lock with value %d", expected);
    }
}
